/*
 * Copyright (c) 2018, Oracle and/or its affiliates. All rights reserved.
 *
 * This software is dual-licensed to you under the MIT License (MIT) and
 * the Universal Permissive License (UPL). See the LICENSE file in the root
 * directory for license terms. You may choose either license, or both.
 */
 
#pragma once
 
#include <VirtualDevice.hpp>
#include <NamedValue.hpp>
 
#include "iotcs.h"
#include "iotcs_virtual_device.h"
 
namespace iotdcl {
    class ActionEventImpl: public ActionEvent<VirtualDevice> {
        std::string name;
        public:
            ActionEventImpl(VirtualDevice *vd, std::string name, NamedValue *value) : ActionEvent<VirtualDevice>(vd, value) {
                this->name = name;
            }
 
            const std::string getName() const {
                return name;
            }
 
            VirtualDevice* getVirtualDevice() {
                return vd;
            }
 
            NamedValue* getNamedValue() const {
                return value;
            }
 
            ~ActionEventImpl() {
            }
    };
};
